<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    plans: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      expanded: false,
    };
  },
  methods: {
    toggleTable() {
      this.expanded = !this.expanded;
    },
    secondaryButtonClick(id) {
      if (id === 'gold-ultimate') {
        this.$emit('on-ultimate-contact-sales-click');
      }
    },
  },
});
</script>

<template>
  <div class="table-container">
    <button
      id="table-control"
      type="button"
      aria-controls="features-table"
      :aria-expanded="expanded"
      :aria-label="`${expanded ? 'Close' : 'Expand'} features table`"
      class="table-toggle"
      data-inbound-analytics="pricing-compare-features"
      :data-ga-toggle="expanded ? 'collapse' : 'expand'"
      @click="toggleTable"
    >
      <SlpTypography id="table-caption" variant="heading4-bold" tag="h3">{{
        data.header
      }}</SlpTypography>
      <SlpIcon
        v-if="expanded"
        class="expand-icon"
        name="dash"
        variant="product"
        alt="Dash Icon"
        size="md"
      />
      <SlpIcon
        v-else
        class="expand-icon"
        name="plus"
        variant="product"
        alt="Plus Icon"
        size="md"
      />
    </button>
    <div
      v-if="expanded"
      id="features-table"
      aria-labelledby="table-control"
      class="features-table"
    >
      <table aria-labelledby="table-caption">
        <thead>
          <tr class="header-row">
            <th class="extended-width"></th>
            <th v-for="plan in plans" :key="plan.id" class="table-header">
              <div class="table-header__content">
                <SlpTypography variant="heading4-bold" tag="h3" class="title">{{
                  plan.title
                }}</SlpTypography>
                <div v-if="plan.id === 'gold-ultimate'">
                  <SlpTypography tag="p" variant="body3" class="price-annually">
                    {{ plan.blurb }}
                  </SlpTypography>
                  <SlpButton
                    variant="primary"
                    :href="plan.additonal_button.url"
                    data-ga-location="compare-features"
                    :data-ga-name="plan.additonal_button.data_ga_name"
                    >{{ plan.additonal_button.text }}</SlpButton
                  >
                </div>
                <div v-else-if="plan.id === 'silver-premium'">
                  <div class="show-if-india">
                    <SlpTypography
                      tag="p"
                      variant="body3"
                      class="price-annually"
                    >
                      For when your growing organization needs to automate
                      software delivery and improve collaboration between teams
                    </SlpTypography>
                    <SlpButton
                      variant="primary"
                      href="/sales/"
                      data-ga-location="compare-features"
                      data-ga-name="sales"
                      >Contact Sales</SlpButton
                    >
                  </div>

                  <SlpTypography
                    variant="body2-bold"
                    class="price hide-if-india"
                    >${{ plan.monthly_price }} {{ plan.price_text }}
                  </SlpTypography>

                  <SlpTypography
                    tag="p"
                    variant="body3"
                    class="price-annually hide-if-india"
                  >
                    {{ plan.billing_type }}
                  </SlpTypography>

                  <div
                    :data-ga-name="plan.data_ga_name"
                    data-ga-location="compare-features"
                    class="hide-if-india"
                    @click="$emit('planSelect', plan)"
                  >
                    <SlpButton
                      :variant="plan.title === 'Free' ? 'tertiary' : 'primary'"
                    >
                      {{ plan.table_button_copy }}
                    </SlpButton>
                  </div>
                </div>
                <div v-else>
                  <SlpTypography variant="body2-bold" class="price"
                    >${{ plan.monthly_price }} {{ plan.price_text }}
                  </SlpTypography>
                  <SlpTypography
                    v-if="plan.monthly_price === 0"
                    tag="p"
                    variant="body3"
                    class="price-annually"
                  >
                    {{ plan.billing_type }}
                  </SlpTypography>
                  <SlpTypography
                    v-else
                    tag="p"
                    variant="body3"
                    class="price-annually"
                  >
                    {{ plan.billing_type }}
                  </SlpTypography>
                  <div
                    :data-ga-name="plan.data_ga_name"
                    data-ga-location="compare-features"
                    @click="$emit('planSelect', plan)"
                  >
                    <SlpButton
                      :variant="plan.title === 'Free' ? 'tertiary' : 'primary'"
                    >
                      {{ plan.table_button_copy }}
                      <SlpIcon
                        v-if="plan.title === 'Free'"
                        class="slp-ml-16"
                        name="chevron-lg-right"
                        variant="product"
                        slp-color="primary-200"
                        alt="Chevron Right Icon"
                      />
                    </SlpButton>
                  </div>
                </div>
              </div>
              <div class="table-header__content__mobile">
                <SlpTypography variant="heading4-bold" tag="h3" class="title">{{
                  plan.title
                }}</SlpTypography>
              </div>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="feature in data.rows"
            :key="feature.text"
            class="features-table__row"
          >
            <th scope="row" class="extended-width feature-label">
              <a
                v-if="feature.link"
                :href="feature.link"
                :data-ga-name="feature.text"
                data-ga-location="body"
              >
                <SlpTypography tag="span" variant="body2">
                  {{ feature.text }}
                </SlpTypography>
              </a>
              <SlpTypography v-else tag="span" variant="body2">
                {{ feature.text }}
              </SlpTypography>
            </th>
            <td class="free">
              <div class="slp-flex slp-justify-content-center">
                <div v-if="feature.values">
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__desktop"
                    >{{ feature.values.free.desktop }}</SlpTypography
                  >
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__mobile"
                    >{{ feature.values.free.mobile }}</SlpTypography
                  >
                </div>
                <SlpIcon
                  v-else-if="feature.tier_level <= 0"
                  :aria-label="`${feature.text} is within free tier.`"
                  name="check"
                  variant="product"
                  slp-color="primary-200"
                  alt="Check icon"
                  size="md"
                />
                <p v-else class="empty-cell">
                  {{ feature.text }} is not within free tier.
                </p>
              </div>
            </td>
            <td class="premium">
              <div class="slp-flex slp-justify-content-center">
                <div v-if="feature.values">
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__desktop"
                    >{{ feature.values.premium.desktop }}</SlpTypography
                  >
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__mobile"
                    >{{ feature.values.premium.mobile }}</SlpTypography
                  >
                </div>
                <SlpIcon
                  v-else-if="feature.tier_level <= 1"
                  :aria-label="`${feature.text} is within premium tier.`"
                  name="check"
                  variant="product"
                  slp-color="primary-200"
                  alt="Check icon"
                  size="md"
                />
                <p v-else class="empty-cell">
                  {{ feature.text }} is not within premium tier.
                </p>
              </div>
            </td>
            <td class="ultimate">
              <div class="slp-flex slp-justify-content-center">
                <div v-if="feature.values">
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__desktop"
                    >{{ feature.values.ultimate.desktop }}</SlpTypography
                  >
                  <SlpTypography
                    variant="body2-bold"
                    class="cell-value__mobile"
                    >{{ feature.values.ultimate.mobile }}</SlpTypography
                  >
                </div>
                <SlpIcon
                  v-else-if="feature.tier_level <= 2"
                  :aria-label="`${feature.text} is within ultimate tier.`"
                  name="check"
                  variant="product"
                  slp-color="accent-500"
                  alt="Check icon"
                  size="md"
                />
                <p v-else class="empty-cell">
                  {{ feature.text }} is not within ultimate tier.
                </p>
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.show-if-india {
  display: none !important;
  flex-direction: column;
  justify-content: space-between;
}
[data-country-code='in'] {
  .show-if-india {
    display: flex !important;
  }
  .hide-if-india {
    display: none !important;
  }
}

.table-container {
  background-color: $color-surface-100;
  margin-bottom: $spacing-96;
  border-radius: $border-radius-4;
}

.features-table {
  padding: 0 $spacing-16;
  padding-bottom: $spacing-48;
  table {
    border-collapse: collapse;
  }
  &__row {
    border-top: $color-surface-400 solid 1px;
    min-height: 48px;
    height: 48px;

    .feature-label {
      text-align: left;
      padding: $spacing-8;

      @media (max-width: $breakpoint-md) {
        overflow-wrap: break-word;
        max-width: 40px;
      }
    }

    .ultimate .check-icon {
      filter: invert(48%) sepia(92%) saturate(3122%) hue-rotate(240deg)
        brightness(86%) contrast(102%);
    }

    .empty-cell {
      // Cell is visually empty but allows text to be read on screen readers
      border: 0;
      clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
      clip: rect(1px, 1px, 1px, 1px);
      height: 1px;
      margin: -1px;
      overflow: hidden;
      padding: 0;
      position: absolute;
      width: 1px;
    }

    .cell-value {
      &__desktop {
        display: none;
        @media (min-width: $breakpoint-lg) {
          display: block;
        }
      }
      &__mobile {
        display: block;
        text-align: center;
        padding: $spacing-8;
        width: 50px;
        @media (min-width: $breakpoint-lg) {
          display: none;
        }
      }
    }

    .free,
    .premium,
    .ultimate {
      border-left: 1px dashed $color-surface-400;
    }
  }
}

.table-toggle {
  color: $color-text-300;
  border: none;
  width: 100%;
  display: flex;
  justify-content: space-between;
  align-items: center;

  cursor: pointer;
  padding: $spacing-16 $spacing-24;
  @media (min-width: $breakpoint-lg) {
    padding: $spacing-24 $spacing-32;
    white-space: nowrap;
  }

  .expand-icon {
    user-select: none;
  }
}

.extended-width {
  width: 100%;
}

.table-header {
  border-left: 1px dashed $color-surface-400;

  &__content {
    max-width: 200px;
    min-width: 200px;
    padding: $spacing-16;
    text-align: left;
    justify-content: space-between;
    display: none;

    @media (max-width: $breakpoint-md) {
      min-width: 0;
    }

    @media (min-width: $breakpoint-lg) {
      display: flex;
      flex-direction: column;
    }

    .title {
      margin-bottom: $spacing-8;
    }

    .price-annually {
      margin-bottom: $spacing-16;
    }

    .slp-btn-tertiary {
      padding-left: 0;
    }

    &__mobile {
      display: block;
      transform: rotate(180deg);
      writing-mode: tb;
      padding: $spacing-16 $spacing-8;

      @media (min-width: $breakpoint-lg) {
        display: none;
      }
    }
  }
}
.header-row {
  background-color: $color-surface-100;
  position: sticky;
  top: 64px;
  z-index: 1;
  box-shadow: 0 8px 50px -50px #45424d;
}
</style>
